/*

* Copyright (c) 2005, The Hong Kong University of Science and Technology (HKUST)
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without 
* modification, are permitted provided that the following conditions 
* are met:
*
*   * Redistributions of source code must retain the above copyright notice, 
*     this list of conditions,the authors and the following disclaimer.
*   * Redistributions in binary form must reproduce the above copyright notice,
*     this list of conditions,the authors and the following disclaimer in
*     the documentation and/or other materials provided with the distribution.
*   * Neither the name of the university nor the names of its 
*     contributors may be used to endorse or promote products derived from 
*     this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
* POSSIBILITY OF SUCH DAMAGE.
*
*/

package StatusSender;

import javax.microedition.midlet.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import java.io.*;

public class StatusSenderMIDlet extends MIDlet implements CommandListener {
	
	private Display display;
	
	private Command yesCommand = new Command("Yes", Command.ITEM, 1);
	private Command noCommand = new Command("No", Command.EXIT, 1);
	private Command exitCommand = new Command("Exit", Command.EXIT, 1);
	private Command sendCommand = new Command("Send", Command.ITEM, 1);
	
	private String ServerIP = "192.168.1.37";  // the IP address of my notebook in the pervasive lab
	
	Sender sd = null;
	
	public StatusSenderMIDlet () 
	  {
		display = Display.getDisplay(this);
		
		Alert a = new Alert("StatusSender", "StatusSender will send the current physical status of the phone to the Aorta server. This will use GPRS and result in charges.\n\nDo you want to continue?",
                    null, AlertType.CONFIRMATION);
                    
        a.setTimeout(Alert.FOREVER);
        a.setCommandListener(this);
        a.addCommand(noCommand);
        a.addCommand(yesCommand);
        
        display.setCurrent(a);		
	  } 
	
	
	public void startApp () {} 
	
	
	public void pauseApp () {} 
	
	
	public void destroyApp (boolean unconditional) 
	  {
		if (sd != null)
		  sd.stop();		
	  } 
	
	
	public void commandAction(Command c, Displayable s) 
	  {
		
		if (c == yesCommand) 
		  {
			TextBox tb = new TextBox("Connection URL to Aorta server:","",100,TextField.URL);
			tb.addCommand(sendCommand);
			tb.addCommand(exitCommand);
            tb.setCommandListener(this);
            
            display.setCurrent(tb);			
		  }
			
			
	    if (c == exitCommand || c == noCommand) 
	      {
        	destroyApp(true);
            notifyDestroyed();            
          } 
        
        
        if (c == sendCommand)  
          {            
            TextBox tb = (TextBox)s;			
            ServerIP = tb.getString();
            // System.out.println("socket://"+ServerIP);        
            
            sd = new Sender(this, "socket://" + ServerIP);
            sd.start();            
		  }	      
      } 
} 