/*

* Copyright (c) 2005, The Hong Kong University of Science and Technology (HKUST)
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without 
* modification, are permitted provided that the following conditions 
* are met:
*
*   * Redistributions of source code must retain the above copyright notice, 
*     this list of conditions,the authors and the following disclaimer.
*   * Redistributions in binary form must reproduce the above copyright notice,
*     this list of conditions,the authors and the following disclaimer in
*     the documentation and/or other materials provided with the distribution.
*   * Neither the name of the university nor the names of its 
*     contributors may be used to endorse or promote products derived from 
*     this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
* POSSIBILITY OF SUCH DAMAGE.
*
*/

package src.MessageDetector;


import javax.microedition.midlet.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import java.io.*;

public class SocketMIDlet extends MIDlet implements CommandListener 
  {

    //private final static String SERVER = "Server";
    //private final static String CLIENT = "Client";

    //private static String[] names = {SERVER, CLIENT};

    private static Display display;
    private Form f;
    //  private ChoiceGroup cg;
    private boolean isPaused;
    private Server server;
    private Client client;

    private Command exitCommand = new Command("Exit", Command.EXIT, 1);
    private Command startCommand = new Command("Start", Command.ITEM, 1);

    public SocketMIDlet() 
      {

        display = Display.getDisplay(this);
        f = new Form("Message Detector");
        /* cg = new ChoiceGroup("Please select peer",
                                            Choice.EXCLUSIVE, names, null);
        f.append(cg);
        */
        f.addCommand(exitCommand);
        f.addCommand(startCommand);
        f.setCommandListener(this);

        display.setCurrent(f);
      }

    public boolean isPaused() 
      {
        return isPaused;
      }

    public void startApp() 
      {
        isPaused = false;
      }


    public void pauseApp() 
      {
        isPaused = true;
      }

    public void destroyApp(boolean unconditional) 
      {
        if (server != null) server.stop();
        
        if (client != null) client.stop();
      }

    public void commandAction(Command c, Displayable s) 
      {
        if (c == exitCommand)
          {
            destroyApp(true);
            notifyDestroyed();
          } 
        else 
          if (c == startCommand) 
            {
              server = new Server(this);
              server.start();                
            }
      }
}

