/*

* Copyright (c) 2006, The Hong Kong University of Science and Technology (HKUST)
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without 
* modification, are permitted provided that the following conditions 
* are met:
*
*   * Redistributions of source code must retain the above copyright notice, 
*     this list of conditions,the authors and the following disclaimer.
*   * Redistributions in binary form must reproduce the above copyright notice,
*     this list of conditions,the authors and the following disclaimer in
*     the documentation and/or other materials provided with the distribution.
*   * Neither the name of the university nor the names of its 
*     contributors may be used to endorse or promote products derived from 
*     this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
* POSSIBILITY OF SUCH DAMAGE.
*
*/

/**
 * Points in 3D Cartesian coordinate.
 */
public class Point {
	
	double x;
	double y;
	double z;
	
	/** Parse a point from its string representation. */
	public static Point parsePoint (String loc) 
	  {
		Point p = new Point();
		int start, stop, end;
		Exception ee = new Exception ();
		
		try 
		  {
			start = loc.indexOf("(");
			if (start == -1) throw ee;
			start += 1;
			end = loc.indexOf(")");
			if (end == -1) throw ee;
			
			stop = loc.indexOf(",",start);
			if (stop == -1 || stop >= end) throw ee;
		    p.x = Double.parseDouble(loc.substring(start,stop).trim());
		    start = stop + 1;
		    
		    stop = loc.indexOf(",",start);
		    if (stop == -1 || stop >= end) throw ee;
		    p.y = Double.parseDouble(loc.substring(start,stop).trim());
		    start = stop + 1;
		    
		    p.z = Double.parseDouble(loc.substring(start,end).trim());	    	
		  }
		catch (Exception e) {e.printStackTrace();}
		
		return p;		
	  }
	
}