/*

* Copyright (c) 2006, The Hong Kong University of Science and Technology (HKUST)
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without 
* modification, are permitted provided that the following conditions 
* are met:
*
*   * Redistributions of source code must retain the above copyright notice, 
*     this list of conditions,the authors and the following disclaimer.
*   * Redistributions in binary form must reproduce the above copyright notice,
*     this list of conditions,the authors and the following disclaimer in
*     the documentation and/or other materials provided with the distribution.
*   * Neither the name of the university nor the names of its 
*     contributors may be used to endorse or promote products derived from 
*     this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
* LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
* POSSIBILITY OF SUCH DAMAGE.
*
*/

import java.io.*;
import java.net.*;

/** 
 * Remote Cost Estimator (RCE) for play a default English phrase on ER1 programmable robots.   
 *  
 * @author Wenwei Xue (wwxue@cs.ust.hk)
 */
public class RCEPlayPhrase {
	
  static final String playPhraseCommand = "play phrase ";
  
  static final String phrase = "\"Please be a little quiet in the lab area. Thanks for your cooperation.\"";
    
  static final String robotIP = "192.168.43.172";
  
  static final int robotPort = 9000;
  
  static final int num = 1;
  
  public static void main(String argv [])
    {
      long playPhraseTime = 0;
      Socket socket;
      
      try
        {
          for (int i=0;i<num;i++)
            {
               socket = new Socket(robotIP,robotPort);
               
               BufferedReader br = new BufferedReader (new InputStreamReader (socket.getInputStream()));
               PrintWriter pw = new PrintWriter (new DataOutputStream(socket.getOutputStream()));
               
               pw.println(playPhraseCommand + phrase);
               pw.println("events");
               pw.flush();
               
               long response_time = System.currentTimeMillis();
                              
               String line = br.readLine().trim();               
               line = br.readLine().trim();          
               while (!line.equals("play done"))
                 {
                 	pw.println("events");
                 	pw.flush();
                 	line = br.readLine();                	
                 }
                 
               response_time = System.currentTimeMillis() - response_time;               
               playPhraseTime += response_time;
                
               br.close();
               pw.close();
             }
      
          System.out.println("Play phrase Time: " + (playPhraseTime / num) + " ms.");                 
        }
      catch (Exception e) {e.printStackTrace();}          		
    }	
 	
}